<template>
  <ObForm
    :form-data="{}"
    @submit="onSubmit"
    :is-submit-disabled="false"
    ok-text="Сохранить изменения"
    data-qa="tenderBuyerEditTableForm"
  >
    <div class="table-description">
      По умолчанию в таблице выбраны только обязательные столбцы.
      Отметьте названия дополнительных столбцов и нажмите кнопку «Сохранить».
    </div>

    <ObTabs v-if="fieldsPurchaser && fieldsSupplier">
      <ObTabsPane
        title="Заполняет закупщик"
        :is-selected="true"
        :tab-button-html="`Заполняет закупщик <span class='text-gray'>${columnsSelected.checkboxBuyer}/${columnsTotal.checkboxBuyer}</span>`"
      >
        <div class="tab-content">
          <TableSection
            referer="checkboxBuyer"
            :data="fieldsPurchaser"
            @calcCheckboxesCount="updateColumnsCount"
            @onCheckboxChange="onCheckboxChange"
            ref="tableSection1"
            data-qa="buyerSection"
          />
        </div>
      </ObTabsPane>

      <ObTabsPane
        title="Заполняет поставщик"
        :tab-button-html="`Заполняет поставщик <span class='text-gray'>${columnsSelected.checkboxCarrier}/${columnsTotal.checkboxCarrier}</span>`"
      >
        <div class="tab-content">
          <TableSection
            referer="checkboxCarrier"
            :data="fieldsSupplier"
            @calcCheckboxesCount="updateColumnsCount"
            @onCheckboxChange="onCheckboxChange"
            ref="tableSection2"
            data-qa="carrierSection"
          />
        </div>
      </ObTabsPane>
    </ObTabs>
  </ObForm>
</template>

<script>
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import ObTabsPane from 'common-components/src/obComponents/obTabs/ObTabsPane'

  import TableSection from '../../components/TableSection'

  export default {
    name: 'editTable',
    components: {
      ObForm,
      ObTabs,
      ObTabsPane,
      TableSection
    },
    data () {
      return {
        columnsTotal: { checkboxBuyer: '-', checkboxCarrier: '-' },
        columnsSelected: { checkboxBuyer: '-', checkboxCarrier: '-' },
        // Special cases for some options
        // https://oboz.myjetbrains.com/youtrack/issue/TND-816
        // https://oboz.myjetbrains.com/youtrack/issue/TND-1069
        // 'isUnidirectional' - triggered only with selected checkboxes
        relations: {
          required_number_of_shipments: {
            isUnidirectional: true,
            action: 'toggle',
            items: [
              'period_of_the_guaranteed_shipments',
              'guaranteed_number_of_shipments'
            ]
          },
          desired_rate: {
            isUnidirectional: false,
            action: 'enable',
            items: [
              'consent_desired_rate'
            ]
          }
        }
      }
    },
    methods: {
      onSubmit () {
        this.$emit('save')
      },
      updateColumnsCount (data) {
        this.columnsTotal[data.sectionReferer] = data.total
        this.columnsSelected[data.sectionReferer] = data.selected
      },
      onCheckboxChange (checkbox) {
        const relation = this.relations[checkbox.code]

        if (!relation || (relation.isUnidirectional && !checkbox.isSelected)) {
          return
        }

        this.filteredCategories.forEach((category) => {
          category.items.forEach((item) => {
            if (relation.items.includes(item.code)) {
              switch (relation.action) {
                case 'toggle':
                  this.$set(item, 'isSelected', checkbox.isSelected)
                  break

                case 'enable':
                  this.$set(item, 'isDisabled', !checkbox.isSelected)

                  if (!checkbox.isSelected) {
                    this.$set(item, 'isSelected', false)
                  }

                  break
              }
            }
          })
        })

        // Recalculate checkboxes count, because
        // we are changed checkboxes state manually
        Object.entries(this.$refs).forEach((tableSection) => {
          tableSection[1].calcCheckboxesCount()
        })
      }
    },
    props: {
      settingsData: {
        type: Object,
        default: () => {}
      }
    },
    computed: {
      filteredCategories () {
        if (!this.settingsData.headers) {
          return null
        }

        let categories = []

        this.settingsData.headers.map((field) => {
          const index = categories.findIndex((category) => {
            return category.title === field.category.title
          })

          if (~index) {
            categories[index].items.push(field)
          } else {
            categories.push({
              ...field.category,
              filler: field.filler,
              items: [field]
            })
          }
        })

        // Сортировка категорий
        categories = categories.sort((a, b) => {
          return a.pos - b.pos
        })

        // Сортировка элементов в категории
        categories = categories.map((category) => {
          return {
            ...category,
            items: category.items.sort((a, b) => {
              return a.pos - b.pos
            })
          }
        })

        return categories
      },
      // Распределение элементов по левой и правой части <ObTabs>
      fieldsPurchaser () {
        if (!this.filteredCategories) {
          return null
        }

        return this.filteredCategories.filter((category) => {
          return category.filler === 'PURCHASER'
        })
      },
      fieldsSupplier () {
        if (!this.filteredCategories) {
          return null
        }

        return this.filteredCategories.filter((category) => {
          return category.filler === 'SUPPLIER'
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .table-description {
    @include font-mixin(14px, 20px, normal, $color-text-base);

    margin-bottom: 10px;
  }

  .tab-content {
    padding-top: 15px;
  }

  /deep/ .text-gray {
    color: $color-grey-span;
  }
</style>
